#no jars in this native build, so skip copying
%define _jarsign_opts --nocopy

%define as_major 5
%define as_minor 2
%define as_rev 0

%define ep5nativehomedir %{_datadir}/native
%define ep5nativedir %{_localstatedir}/lib/native
%define jbhomedir %{_localstatedir}/lib/jbossas

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with with_patch_zip

Summary:        JBoss EAP 5 native zip
Name:           jboss-eap5-native
Version:        %{as_major}.%{as_minor}.%{as_rev}
##############################################################################
### ***** Please check latest apr-util in base RHEL is  ********
### the latest-pkg in buildroot when rebuilding this package
### brew latest-pkg RHEL-6-build apr apr-util
### brew latest-pkg jb-eap-5-rhel-6-build apr apr-util
##############################################################################
Release:        6%{?dist}
Epoch:          0
License:        LGPL
Group:          Development/Installer
URL:            http://www.jboss.org/

BuildRequires: jpackage-utils,zip,unzip

BuildRequires: apr >= 0:1.2.7-11.el5_5.2
BuildRequires: apr-util
BuildRequires: tomcat-native >= 0:1.1.20
BuildRequires: mod_jk-ap20 >= 0:1.2.31
BuildRequires: mod_cluster-native >= 0:1.0.10
BuildRequires: hornetq-native >= 0:2.2.11
BuildRequires: java-devel
Requires:      apr
Requires:      apr-util
Requires:      tomcat-native >= 0:1.1.20
#The following should be Optional as they requires httpd from EWS
#Requires:      mod_jk-ap20
#Requires:      mod_cluster

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This package is a container for the EAP 5 native zip.

%package monolithic-zip
Summary:        Monolithic .zip for all of EAP 5 native bits
Group:          Development

%description monolithic-zip
Monolithic .zip for all of EAP 5 native bits

%prep

%build
mkdir jboss-ep-%{as_major}.%{as_minor}
pushd jboss-ep-%{as_major}.%{as_minor}
%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif
    mkdir -p native/$libdir/httpd/modules
    # apr, tcnative, mod_jk
    ln -s %{_libdir}/libapr*1* native/$libdir/
    cp -pL %{_libdir}/libtcnative* native/$libdir/
    cp -p %{_libdir}/httpd/modules/mod_jk.so native/$libdir/httpd/modules/
    # mod_cluster
    cp -p %{_libdir}/httpd/modules/mod_{slotmem,proxy_cluster,manager,advertise}.so native/$libdir/httpd/modules/
    # hornetq-native
    cp -pL %{_libdir}/libHornetQ* native/$libdir/
    chmod -R 755 native/$libdir/*libHornetQ*
popd
%if ! %with with_patch_zip
zip -q -r -y jboss-ep-native-%{version}-RHEL6-%{_arch}.zip jboss-ep-%{as_major}.%{as_minor}
%else
zip -y jboss-ep-native-%{version}-CVE-2011-4608-RHEL6-%{_arch}.zip jboss-ep-%{as_major}.%{as_minor}/native/$libdir/httpd/modules/mod_manager.so
%endif

rm -rf jboss-ep-%{as_major}.%{as_minor}

%install
rm -rf $RPM_BUILD_ROOT
#install -dm 755 $RPM_BUILD_ROOT/%{ep5nativedir}/lib/httpd/modules
%ifarch x86_64
libdir=lib64
%else
libdir=lib
%endif
install -dm 755 $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir
install -dm 755 $RPM_BUILD_ROOT/%{_datadir}
install -dm 755 $RPM_BUILD_ROOT/%{jbhomedir}
(cd $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir && for i in `ls %{_libdir}/libtcnative*`; do ln -s $i .; done)
(cd $RPM_BUILD_ROOT/%{ep5nativedir}/$libdir && for i in `ls %{_libdir}/libapr*`; do ln -s $i .; done)

#Optional as they requires httpd22
#( cd $RPM_BUILD_ROOT/%{ep5nativedir}/lib/httpd/modules && for i in mod_slotmem.so mod_proxy_cluster.so mod_manager.so mod_jk.so mod_advertise.so; do ln -sf %{_libdir}/httpd22/modules/$i .; done)

(cd $RPM_BUILD_ROOT/%{_datadir} && ln -sf %{ep5nativedir}/ native)

install -dm 755 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/
install -m 644 *.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev

%pre
JBOSS_SHELL=/sbin/nologin
%{_sbindir}/groupadd -r jboss 2>/dev/null || :
%{_sbindir}/useradd -c JBossAS -r -s $JBOSS_SHELL -d %{jbhomedir} -g jboss jboss 2>/dev/null || :

%files
%defattr(0644,jboss,jboss,0755)
%dir %{ep5nativehomedir}
%dir %{ep5nativedir}
%ifarch x86_64
%dir %{ep5nativedir}/lib64
%{ep5nativedir}/lib64/*
%else
%dir %{ep5nativedir}/lib
%{ep5nativedir}/lib/*
%endif
#Optional as they requires httpd22
#%dir %{ep5nativedir}/lib/httpd
#%dir %{ep5nativedir}/lib/httpd/modules
#%{ep5nativedir}/lib/httpd/modules/*

%files monolithic-zip
%defattr(-,root,root,-)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/*.zip

%changelog
* Tue Nov 20 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-6
- Rebuild to include new mod_cluster-native patch JBPAPP-10029

* Mon Oct 15 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-5
- Rebuild to include mod_cluster-native patch JBPAPP-10029

* Thu Sep 27 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-4
- Rebuild for mod_cluster-native retag

* Wed Sep 26 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-3
- Rebuild for mod_cluster-native upgrade to 1.0.10.GA_CP04

* Wed Aug 15 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-2
- Rebuild for hornetq-native upgrade to 2.2.11

* Tue Aug 14 2012 Permaine Cheung <pcheung@redhat.com> 5.2.0-1
- Build for EAP 5.2.0 (with mod_cluster-native upgrade)

* Thu Dec 15 2011 Permaine Cheung <pcheung@redhat.com> 5.1.2-1.5
- Fix for mod_cluster CVE-2011-4608
- Add with_patch_zip flag

* Mon Sep 12 2011 Permaine Cheung <pcheung@redhat.com> 5.1.2-1.4
- Rebuild to pick up latest hq-native

* Mon Sep 12 2011 Permaine Cheung <pcheung@redhat.com> 5.1.2-1.3
- Use symlinks instead of copying apr libraries (JBPAPP-5585)

* Tue Aug 23 2011 Permaine Cheung <pcheung@redhat.com> 5.1.2-1.2
- 5.1.2 build to includde mod_cluster-native-1.0.10.GA_CP02

* Fri Jun 11 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-3.2
- Rebuild to pick up latest mod_cluster-native-1.0.10.GA_CP01

* Fri May 20 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-2.2
- Rebuild to pick up latest apr with a fix for CVE-2011-1928

* Thu May 12 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-1.2
- Rebuild to pick up latest apr with a fix for CVE-2011-0419

* Tue Apr 05 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.4.1.2
- Include hornetq native

* Tue Mar 29 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.4.1.1
- Rebuild to pick up hq-native 2.2.2

* Tue Mar 22 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.3.1.1
- Rebuild to pick up mod_cluster 1.0.9

* Thu Mar 17 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.2.1.1
- Fix jbhomedir (JBPAPP-5085)

* Fri Feb 18 2011 Permaine Cheung <pcheung@redhat.com> 5.1.1-0.1.1.1
- Build for 5.1.1

* Thu Nov 25 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-13.1.1
- Rebuild to pick up mod_cluster-native 1.0.5
- Specify nocopy for signing step

* Thu Oct 14 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-12.2
- Fix the name of the zips
- Do not include hornetq native libs for now

* Mon Sep 20 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-12.1
- Install 64 bit libraries at lib64 instead of lib

* Wed Aug 18 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-11.2
- Rebuild to pick up latest hornetq-native 2.1.2.Final

* Wed Aug 18 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-11.1
- Rebuild to pick up latest apr

* Wed Jul 28 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-10.1
- Rebuild to pick up mod_cluster-native 1.0.4

* Fri Jul 23 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-9.1
- Add define for jbhomedir

* Wed Jul 21 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-8.1
- Add the creation of jboss user and group

* Thu Jul 15 2010 Yiqiao Wang <yiwang@redhat.com> 5.1.0-7.1
- Merge with RHEL4

* Thu Jul 15 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-7
- Remove hornetq-native as a Requires because it is not needed for EWP,
  it should be a R: in the jbossas-hornetq package

* Thu Jun 24 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-6.1
- Rebuild with latest mod_cluster-native rebuild

* Tue Jun 22 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-5.1
- Rebuild with latest mod_cluster-native rebuild

* Fri Jun 18 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-4.1
- Rebuild with latest mod_cluster, tomcat-native rebuild

* Wed Jun 16 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-3.1
- Build with latest hornetq-native (built from 2.1.1.Final)

* Fri Jun 04 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-2.1
- Build with latest hornetq-native (built from 2.1.0.Final)

* Thu Jun 03 2010 Permaine Cheung <pcheung@redhat.com> 5.1.0-1.1
- Add hornetq-native
- Rename top dir to jboss-ep
- BR mod_cluster-native instead of the zip

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:5.0.1-5.2.1.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 5.0.1-5.2.1
- Rebuild

* Thu Apr 01 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-5.2
- Rebuild

* Wed Mar 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-5.1
- Merge with RHEL-4-EP-5 branch

* Wed Mar 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-5
- Do not R: httpd22-apr* either as we cannot just ship the subpackages only

* Wed Mar 24 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-4
- Mark mod_jk and mod_cluster as optional as they R: httpd22 from EWS

* Tue Mar 16 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-3
- Fix directory structure

* Tue Mar 16 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-2
- Add main package for installation

* Thu Feb 11 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-1.1
- Merge with RHEL-4-EP-5 branch

* Thu Feb 11 2010 Permaine Cheung <pcheung@redhat.com> 5.0.1-1
- Build for EAP 5.0.1

* Mon Jan 25 2010 Permaine Cheung <pcheung@redhat.com> 5.0.0-14.1
- Rebuild

* Tue Jan 19 2010 Permaine Cheung <pcheung@redhat.com> 5.0.0-13.1
- Merge with RHEL-4-EP-5 branch

* Tue Jan 19 2010 Permaine Cheung <pcheung@redhat.com> 5.0.0-13
- Use mod_cluster 1.0.3
- Fix names of the zips and permission on the libraries for mod_cluster

* Mon Dec 07 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-12.2
- Do not produce the native zips for now

* Mon Dec 07 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-12.1
- Merge with RHEL 4 EP 5 branch

* Thu Nov 05 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-9.1
- Merge with RHEL 4 for adding mod_cluster to the zip

* Mon Jul 27 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-5.1
- Update directory structure

* Sun Jul 26 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-4.1
- Fix directory structure

* Fri Jul 24 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-3.1
- Fix name of zip

* Thu Jul 23 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-2.1
- Change directory structure and name of zip

* Wed Jul 22 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-1.1
- Fix name of the zip

* Tue Jul 21 2009 Permaine Cheung <pcheung@redhat.com> 5.0.0-1
- First build
